package edu.jhmi.telometer;

import edu.jhmi.telometer.controller.GeneralController;
import edu.jhmi.telometer.interfce.HardConstants;
import edu.jhmi.telometer.repo.TissueTypeRepo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Bean;

@SpringBootApplication
public class MainApplication {

	private static final Logger log = LoggerFactory.getLogger(MainApplication.class);

	public static void main(String[] args) {
		try{
			mainDelegate(args);
		} catch (Throwable t){
			log.error("General error: " + t, t);
			throw t;
		}
	}

	private static void mainDelegate(String[] args){
		log.info("Telometer MainApplication starting...");
		SpringApplication.run(MainApplication.class, args);
	}

	@Bean
	public CommandLineRunner startTheApp(GeneralController generalController) {
		return (args) -> {
			generalController.startup();
		};
	}


}
