package edu.jhmi.telometer.bean;

public enum AdminType {
    PROJECT(Project.class),
    TISSUE_TYPE(TissueType.class),
    LESION_TYPE(LesionType.class),
    CELL_TYPE(CellType.class),
    PRESET(Preset.class);

    private final Class clazz;

    AdminType(Class clazz) {
        this.clazz = clazz;
    }

    public Class getClazz() {
        return clazz;
    }

    public static AdminType clazzToLookupType(Class clazz) {
        for (AdminType adminType : AdminType.values()){
            if (adminType.getClazz().equals(clazz)){
                return adminType;
            }
        }
        return null;
    }

    public String toString(){
        return clazz.getSimpleName();
    }
}
