package edu.jhmi.telometer.bean;

import edu.jhmi.telometer.interfce.Named;
import edu.jhmi.telometer.interfce.TreeObject;
import lombok.Builder;
import lombok.Data;
import lombok.ToString;
import lombok.experimental.Tolerate;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;

@Entity
@Table(
        uniqueConstraints=
        @UniqueConstraint(columnNames={"scoringId", "name"})
)
@Data
@Builder
public class Cell implements Named, TreeObject {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name="scoringId", nullable=false)
    @ToString.Exclude
    private Scoring scoring;

    @Basic
    @Column(nullable = false)
    private String name;

    @Basic
    @Column(nullable = false)
    private int x;

    @Basic
    @Column(nullable = false)
    private int y;

    @Basic
    @Column(nullable = false)
    private int width;

    @Basic
    @Column(nullable = false)
    private int height;

    @ManyToOne
    @JoinColumn(name="lesionTypeId", nullable=false)
    private LesionType lesionType;

    @ManyToOne
    @JoinColumn(name="cellTypeId", nullable=false)
    private CellType cellType;

    @ManyToOne
    @JoinColumn(name="tissueTypeId", nullable=false)
    private TissueType tissueType;

    @Basic
    @Column(nullable = true)
    private String notes;

    @Basic
    @Column(nullable = false)
    private long sum;

    @Basic
    @Column(nullable = false)
    private int area;

    @Basic
    @Column(nullable = false)
    private int min;

    @Basic
    @Column(nullable = false)
    private int max;

    @Basic
    @Column(nullable = false)
    private long stddev1000;

    @Basic
    @Column(nullable = false)
    private long mean1000;

    @Basic
    @Column(nullable = false)
    private long cy3Noise1000;

    @Basic
    @Column(nullable = true)
    private Integer cellCount;

    @Transient
    private TelomereStat telomereStat;

    @Tolerate
    public Cell(){

    }

}

