package edu.jhmi.telometer.bean;

import edu.jhmi.telometer.interfce.Named;
import lombok.Builder;
import lombok.Data;
import lombok.experimental.Tolerate;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Data
@Builder
public class Preset implements Named {

    @Id
    @GeneratedValue(strategy= GenerationType.IDENTITY)
    private Long id;

    @Basic
    @Column(nullable = false, unique = true)
    private String name;

    @Basic
    @Column(nullable = false)
    private int minSpotSize;

    @Basic
    @Column(nullable = false)
    private int maxSpotSize;

    @Basic
    @Column(nullable = false)
    private int rollingBallSize;

    @Basic
    @Column(nullable = false)
    private long despeckleRatio1000; // 500 represents a real despeckleRatio of .5

    @Tolerate
    public Preset(){

    }

    public String toString(){
        return name;
    }
}
