package edu.jhmi.telometer.bean;

import edu.jhmi.telometer.interfce.Ided;
import edu.jhmi.telometer.interfce.TreeObject;
import lombok.Builder;
import lombok.Data;
import lombok.ToString;
import lombok.experimental.Tolerate;

import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

@Entity
@Table(
        uniqueConstraints=
        @UniqueConstraint(columnNames={"cellId", "telomereNumber"})
)
@Data
@Builder
public class Telomere implements TreeObject, Ided {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name="cellId", nullable=false)
    @ToString.Exclude
    private Cell cell;

    @Basic
    @Column(nullable = false)
    private int telomereNumber;

    @Basic
    @Column(nullable = false)
    private int x;

    @Basic
    @Column(nullable = false)
    private int y;

    @Basic
    @Column(nullable = false)
    private long sum;

    @Basic
    @Column(nullable = false)
    private int min;

    @Basic
    @Column(nullable = false)
    private int max;

    @Basic
    @Column(nullable = false)
    private int area;

    @Basic
    @Column(nullable = false)
    private long mean1000;

    @Basic
    @Column(nullable = false)
    private long stddev1000;


    @Tolerate
    public Telomere(){

    }

}

