package edu.jhmi.telometer.calc.api;

import edu.jhmi.telometer.bean.Dimension;
import edu.jhmi.telometer.bean.Image;
import edu.jhmi.telometer.bean.Mask;
import edu.jhmi.telometer.bean.Pixelation;
import edu.jhmi.telometer.bean.Point;
import edu.jhmi.telometer.bean.Rect;
import ij.ImagePlus;
import ij.process.ImageProcessor;

import java.util.Set;

public interface MaskConvertUtil {

    Pixelation imageAndMaskToPixelation(Image image, Mask mask); //returns just the pixels in the mask
    ImagePlus maskToImagePlus(Mask mask); //useful debugging
    Mask byteImageProcessorToMask(ImageProcessor imageProcessor); //useful to turn imageJ's mask into our Mask data structure
    Mask nonZeroImageToMask(Image image);

    Set<Point> maskToPoints(Mask mask); //useful for particles
    Mask pointsToMask(Set<Point> points, Dimension dimension); //useful for particles

    Mask rectToRectPartialMask(Rect rect);
    Mask rectPartialMaskToFullMask(Mask partialRectMask, Rect rect, Image image);

    Point averagePoint(Mask mask);
}
