package edu.jhmi.telometer.calc.api;

import edu.jhmi.telometer.bean.Image;
import edu.jhmi.telometer.bean.Mask;
import edu.jhmi.telometer.bean.Pixelation;
import ij.ImagePlus;
import ij.gui.Roi;

public interface PixelModifier {

    /** Unlike a canvasOverlay, this actually changes the underlying
     * pixels of an imagePlus.  (This is needed before writing the imagePlus to a file,
     * or doing math on the imagePlus.)
     */
    void applyRoiToImagePlus(Roi roi, ImagePlus imagePlus);

    Pixelation subtractIntensity(Pixelation pixelation, int intensity);

    Image zeroOutNonMask(Image image, Mask mask);
}
