package edu.jhmi.telometer.calc.impl;

import edu.jhmi.telometer.bean.Mask;
import edu.jhmi.telometer.bean.Particle;
import edu.jhmi.telometer.bean.Point;
import edu.jhmi.telometer.calc.api.MaskConvertUtil;
import edu.jhmi.telometer.calc.api.ParticleUtil;
import edu.jhmi.telometer.calc.api.ParticleUtilHelper;
import lombok.extern.slf4j.Slf4j;

import java.util.HashSet;
import java.util.Set;

@Slf4j
public class ParticleUtilImpl implements ParticleUtil {

    private ParticleUtilHelper particleUtilHelper = new ParticleUtilHelperImpl();
    private MaskConvertUtil maskConvertUtil = new MaskConvertUtilImpl();

    @Override
    public Set<Mask> breakImageMaskIntoParticles(Mask mask) {
        Set<Point> points = maskConvertUtil.maskToPoints(mask);
        Set<Particle> particles = particleUtilHelper.pointsToParticles(points);
        Set<Mask> returned = new HashSet();
        for (Particle particle : particles){
            Mask particleMask = maskConvertUtil.pointsToMask(particle.getPoints(), mask.getDimension());
            returned.add(particleMask);
        }
        return returned;
    }
}
