package edu.jhmi.telometer.calc.impl;

import edu.jhmi.telometer.bean.Pixelation;
import edu.jhmi.telometer.bean.Stat;
import edu.jhmi.telometer.calc.api.StatUtil;
import edu.jhmi.telometer.calc.api.StatUtilHelper;

public class StatUtilImpl implements StatUtil {

    private StatUtilHelper statUtilHelper = new StatUtilHelperImpl();

    @Override
    public Stat calcStat(Pixelation pixelation) {
        return Stat.builder()
                .min(statUtilHelper.min(pixelation))
                .max(statUtilHelper.max(pixelation))
                .area(statUtilHelper.area(pixelation))
                .mean1000(statUtilHelper.mean1000(pixelation))
                .sum(statUtilHelper.sum(pixelation))
                .stddev1000(statUtilHelper.stddev1000(pixelation))
                .build();
    }

}
