package edu.jhmi.telometer.service.impl;

import edu.jhmi.telometer.bean.Cell;
import edu.jhmi.telometer.bean.Project;
import edu.jhmi.telometer.bean.Scoring;
import edu.jhmi.telometer.bean.Telomere;
import edu.jhmi.telometer.repo.CellRepo;
import edu.jhmi.telometer.repo.ProjectRepo;
import edu.jhmi.telometer.repo.ScoringRepo;
import edu.jhmi.telometer.repo.TelomereRepo;
import edu.jhmi.telometer.service.api.TreeService;
import edu.jhmi.telometer.util.CellTransientPopulator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.HashSet;
import java.util.List;

@Component
public class TreeServiceImpl implements TreeService {

    @Autowired
    private ProjectRepo projectRepo;

    @Autowired
    private ScoringRepo scoringRepo;

    @Autowired
    private CellRepo cellRepo;

    @Autowired
    private TelomereRepo telomereRepo;

    private CellTransientPopulator cellTransientPopulator = new CellTransientPopulator();


    @Override
    public List<Project> findAllProjects() {
        return projectRepo.findAll();
    }

    @Override
    public List<Scoring> findScoringsByProject(Project project) {
        return scoringRepo.findScoringsByProject(project);
    }

    @Override
    public List<Cell> findCellsByScoring(Scoring scoring) {
        List<Cell> cells = cellRepo.findCellsByScoring(scoring);
        List<Telomere> telomeres = telomereRepo.findTelomeresByCellIn(new HashSet(cells));
        cellTransientPopulator.populateCellsTransientFields(cells, telomeres);
        return cells;
    }

    @Override
    public List<Telomere> findTelomeresByCell(Cell cell) {
        return telomereRepo.findTelomeresByCell(cell);
    }
}


