package edu.jhmi.telometer.util;

import edu.jhmi.telometer.bean.Cell;
import edu.jhmi.telometer.bean.Telomere;
import edu.jhmi.telometer.bean.TelomereStat;
import edu.jhmi.telometer.calc.api.TelomereStatsCalculator;
import edu.jhmi.telometer.calc.impl.TelomereStatsCalculatorImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.Assert;

import java.util.Collection;
import java.util.Set;
import java.util.stream.Collectors;

@Slf4j
public class CellTransientPopulator {

    private TelomereStatsCalculator telomereStatsCalculator = new TelomereStatsCalculatorImpl();

    public void populateCellsTransientFields(Collection<Cell> cells, Collection<Telomere> telomeres){
        cells.forEach(cell ->{
            Set<Telomere> partialTelomeres = telomeres.stream().filter(t -> t.getCell().getId().equals(cell.getId())).collect(Collectors.toSet());
            TelomereStat telomereStat = telomereStatsCalculator.telomeresToStats(partialTelomeres, cell);
            cell.setTelomereStat(telomereStat);
        });
    }

}
