package edu.jhmi.telometer.util;

import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.List;

@Slf4j
public class FileUtils {

    private static final String TAB = "\t";

    public static void writeListToFile(List<List<String>> lists, File file){
        log.info("writing to file: {}", file.getAbsolutePath());
        PrintWriter printWriter = null;
        try {
            printWriter = new PrintWriter(file);
            for (List<String> list : lists){
                String line = String.join(TAB, list);
                printWriter.println(line);
            }
            printWriter.flush();
        } catch (IOException e){
            throw new RuntimeException(e);
        } finally{
            if (printWriter != null) {
                printWriter.close();
            }
        }
    }

    public static void writeBytesToFile(byte[] bytes, File file){
        log.info("writing bytes to file.  length: {}. file:{}", bytes.length,
                file.getAbsolutePath());
        try (FileOutputStream fos = new FileOutputStream(file)) {
            fos.write(bytes);
        } catch (IOException e) {
            throw new RuntimeException("Could not write file: " + file + " because of exception: " + e, e);
        }
    }
}
