package edu.jhmi.telometer.util;

import edu.jhmi.telometer.bean.NucleusEntry;
import org.springframework.util.Assert;

import java.util.HashSet;
import java.util.Set;

public class NucleusHolder {

    private final Set<NucleusEntry> nucleusEntrys = new HashSet<>();

    public void addNucleusEntry(NucleusEntry nucleusEntry){
        Assert.isNull(findByName(nucleusEntry.getName()), "name already used: " + nucleusEntry);
        nucleusEntrys.add(nucleusEntry);
    }

    public void removeByName(String name){
        NucleusEntry nucleusEntry = findByName(name);
        if (nucleusEntry != null){
            nucleusEntrys.remove(nucleusEntry);
        }
    }

    public void clear(){
        nucleusEntrys.clear();
    }

    private NucleusEntry findByName(String name){
        name = name.trim().toLowerCase();
        for (NucleusEntry nucleusEntry : nucleusEntrys){
            if (nucleusEntry.getName().trim().toLowerCase().equals(name)){
                return nucleusEntry;
            }
        }
        return null;
    }



    public boolean nameExists(String name){
        return findByName(name) != null;
    }

    public String getNextName(){
        for (int i = 1; i < 9999; i++){
            String name = "N" + i;
            if (!nameExists(name)){
                return name;
            }
        }
        return "N0";
    }

    public boolean isEmpty(){
        return nucleusEntrys.isEmpty();
    }

    public Set<NucleusEntry> getNucleusEntrys() {
        return nucleusEntrys;
    }
}
