package edu.jhmi.telometer.util;

import edu.jhmi.telometer.bean.ToolMode;
import edu.jhmi.telometer.thirdparty.Toggle_Paintbrush_;
import ij.ImagePlus;
import ij.gui.Toolbar;

public class ToolModeUtil {



    public static void setToolMode(ToolMode toolMode, ImagePlus imagePlus) {
        setDrawModeEnabled(toolMode.isDraw(), imagePlus);
        switch (toolMode) {
            case HAND: {
                Toolbar.getInstance().setTool(Toolbar.HAND);
                break;
            }
            case ZOOM: {
                Toolbar.getInstance().setTool(Toolbar.MAGNIFIER);
                break;
            }
            case DRAW:{
                break;
            }
            default: {
                throw new RuntimeException("bad toolMode: " + toolMode);
            }
        }
    }

    private static void setDrawModeEnabled(boolean isDrawModeEnabled, ImagePlus imagePlus) {
        Toggle_Paintbrush_ toggle_paintbrush_ = new Toggle_Paintbrush_();
        toggle_paintbrush_.setup(null, imagePlus);
        toggle_paintbrush_.run(imagePlus.getProcessor(), isDrawModeEnabled);
    }


//    public boolean isDrawModeOn(){
//        boolean fOldFound = false;
//        for (int i=0; i<newML.length; i++) {
//            if (newML[i].getClass() == Toggle_Paintbrush_ .class) {
//                // we found one
//                ((Toggle_Paintbrush_ )newML[i]).removeYourself();
//                fOldFound = true;
//            }
//        }
//    }

}
