package edu.jhmi.telometer.view.about;

import edu.jhmi.telometer.util.DialogUtil;
import java.awt.Component;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class GplDialog {
	
	private static final String GPL_FILE = "GPL.txt";
	
	public static void displayGPL(Component parentComponent){

		String gplText = null;
		try{
			gplText= readInternalString(GPL_FILE);
		} catch (IOException e){
			String error = "Could not display the GNU GPL, which is Telometer's license.\n"
				+ "Please see the Free Software Foundation's website for the GPL version 3." + e;
			DialogUtil.displayInfoDialog(parentComponent, error);
			return;
		}
		DialogUtil.displayInfoDialog(parentComponent, gplText);
	}


	
	private static String readInternalString(String resourceName) throws IOException {
		StringBuilder string = new StringBuilder();
		InputStream inputStream = Thread.currentThread().getContextClassLoader().getResourceAsStream(GPL_FILE);
		BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
		String line = null;
		while ((line = bufferedReader.readLine()) != null){
			 string.append(line + "\n");
		}
		return string.toString();
	}
}
