package edu.jhmi.telometer.view.query.table;

import edu.jhmi.telometer.bean.ColumnSpec;
import edu.jhmi.telometer.util.TableUtil;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.BorderLayout;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class GeneralTablePanel<T> {


    private final GeneralTableModel<T> tableModel;
    private final JTable table;
    private final JScrollPane scrollPane;
    private final JPanel mainPanel = new JPanel(new BorderLayout());

    public GeneralTablePanel(List<ColumnSpec<T>> columnSpecs) {
        tableModel = new GeneralTableModel(columnSpecs);
        table = new JTable(tableModel);
        scrollPane  = new JScrollPane(table);


        mainPanel.add(scrollPane, BorderLayout.CENTER);
        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    }

    public void setRows(List<T> rows){
        tableModel.setRows(rows);
        TableUtil.expandColumns(table);
    }

    public Set<T> getSelectedObjects(){
        int[] indices = table.getSelectedRows();
        Set<T> selectedObjects = new HashSet();
        List<T> rows = tableModel.getRows();
        for (int index : indices){
            T selectedObject = rows.get(index);
            selectedObjects.add(selectedObject);
        }
        return selectedObjects;
    }

    public JPanel getMainPanel() {
        return mainPanel;
    }

    public GeneralTableModel<T> getTableModel() {
        return tableModel;
    }
//
//    public JTable getTable() {
//        return table;
//    }
}
