package edu.jhmi.telometer.view.score;

import edu.jhmi.telometer.interfce.ScorePanelListener;
import org.springframework.util.Assert;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.Dimension;
import java.awt.Scrollbar;
import java.util.HashSet;
import java.util.Set;

public class ThresholdPanel {

    private final JSlider minSlider = new JSlider(Scrollbar.HORIZONTAL,  0, 256, 0);
    private final JLabel minSliderLabel = new JLabel("0");
    private final JPanel thresholderPanel = new JPanel();
    private ScorePanelListener scorePanelListener;

    private boolean isInitted;

    public ThresholdPanel(){
        initGuiIfNecessary();
    }

    private void initGuiIfNecessary() {
        if (isInitted) {
            return;
        }
        thresholderPanel.add(minSlider);
        thresholderPanel.add(minSliderLabel);

        minSlider.addChangeListener(a -> minSliderStateChanged(a));
        isInitted = true;
    }

    private void minSliderStateChanged(ChangeEvent changeEvent) {
        Assert.notNull(scorePanelListener, "scorePanelListener is null");
        minSliderLabel.setText(minSlider.getValue() + "");
        scorePanelListener.minSliderAdjustment(minSlider.getValue());
    }

    public JPanel getPanel(){
        return thresholderPanel;
    }

    public void setMinSliderValue(int minValue) {
        minSlider.setValue(minValue);
    }


    public void setScorePanelListener(ScorePanelListener scorePanelListener) {
        this.scorePanelListener = scorePanelListener;
    }

    public void setWidth(int width) {
        minSlider.setPreferredSize(new Dimension(width, (int) minSlider.getPreferredSize().getHeight()));
    }
}
