package edu.jhmi.telometer.util;

import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;

@Slf4j
class DoubleUtilTest {

    @Test
    public void dblTest(){
        final double dbl = 1283456.5927;
        long long1000 = DoubleUtil.doubleToLong1000(dbl);
        double returned = DoubleUtil.long1000ToDouble(long1000);
        assertEquals(dbl, returned, 0.0005);
    }

    @Test
    public void average(){
        List<Integer> list = Arrays.asList(5, 2, 3);
        double value = list.stream().mapToLong(t -> t).average().getAsDouble();
        assertEquals(3.333, value, 0.0005);
    }

}