package edu.jhmi.telometer.util.impl;

import edu.jhmi.telometer.bean.Image;
import org.junit.jupiter.api.Test;

import java.io.File;

import static org.junit.jupiter.api.Assertions.*;

class ImageDirUtilImplTest {

    @Test
    void isValidFileNameExtension() {
        assertTrue(ImageDirUtilImpl.isValidFileNameExtension("a.jpg"));
        assertFalse(ImageDirUtilImpl.isValidFileNameExtension("ajpg"));
        assertTrue(ImageDirUtilImpl.isValidFileNameExtension("abc.tiff"));
        assertTrue(ImageDirUtilImpl.isValidFileNameExtension("abc.tif"));
        assertTrue(ImageDirUtilImpl.isValidFileNameExtension("abc.TIF"));
        assertFalse(ImageDirUtilImpl.isValidFileNameExtension("abc.tif.else"));
        assertTrue(ImageDirUtilImpl.isValidFileNameExtension("abc.jpg"));
        assertFalse(ImageDirUtilImpl.isValidFileNameExtension("abc.jpeg"));
    }

    @Test
    void isValidFileNameName() {
        assertTrue(ImageDirUtilImpl.isValidFileNameName("cy3.whatever"));
        assertTrue(ImageDirUtilImpl.isValidFileNameName("CY3.whatever"));
        assertFalse(ImageDirUtilImpl.isValidFileNameName("dy3.whatever"));
        assertTrue(ImageDirUtilImpl.isValidFileNameName("annotated.whatever"));
        assertFalse(ImageDirUtilImpl.isValidFileNameName("something.whatever"));
    }

    @Test
    void isInPath() {
        File file1 = new File("target/classes");
        File file2 = new File("target");
        assertTrue(ImageDirUtilImpl.isInPath(file2, file1));
        assertFalse(ImageDirUtilImpl.isInPath(file1, file2));
    }
}